/*
  Copyright (c) 2003, 2004 Darren Horrocks
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
    1. Redistributions of source code must retain the above copyright
       notice, this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.
    3. The name of the author may not be used to endorse or promote products
       derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* 
  Darrens Generic Maped EQ Script v1.0
  usage

  you must put this at the bottom of the layout or group that the volume
  layer is in

  <script file="path/to/script/eq.maki"/>

  you will need:
    ill add this later
*/

#include <lib/std.mi>

Global Group thisGroup;
Global Map thisMap;
Global Layer eql1, eql2, eql3, eql4, eql5, eql6, eql7, eql8, eql9, eql10, eqp;
Global List eqList;

System.onScriptLoaded() {
  thisGroup = getScriptGroup();

  thisMap = new map;
  thisMap.loadMap("eq.map");

  eql1 = thisGroup.getObject("eq.s.1");
  eql2 = thisGroup.getObject("eq.s.2");
  eql3 = thisGroup.getObject("eq.s.3");
  eql4 = thisGroup.getObject("eq.s.4");
  eql5 = thisGroup.getObject("eq.s.5");
  eql6 = thisGroup.getObject("eq.s.6");
  eql7 = thisGroup.getObject("eq.s.7");
  eql8 = thisGroup.getObject("eq.s.8");
  eql9 = thisGroup.getObject("eq.s.9");
  eql10 = thisGroup.getObject("eq.s.10");
  eqp = thisGroup.getObject("eq.p.l");

  eqList = new List;

  eqList.addItem(eql1);
  eqList.addItem(eql2);
  eqList.addItem(eql3);
  eqList.addItem(eql4);
  eqList.addItem(eql5);
  eqList.addItem(eql6);
  eqList.addItem(eql7);
  eqList.addItem(eql8);
  eqList.addItem(eql9);
  eqList.addItem(eql10);

  for(int x=0;x<10;x++) {
    onEqBandChanged(x,getEqBand(x));
  }

  onEqPreampChanged(getEqPreamp());
}

System.onEqBandChanged(int band, int newvalue) {
  Layer cLayer = eqList.enumItem(band);
  cLayer.setRegionFromMap(thisMap,newvalue-127,1);
}

System.onEqPreampChanged(int newvalue) {
  eqp.setRegionFromMap(thisMap,newvalue-127,1);
}